package DX::Op::MemberOf;

use DX::ArrayStream;
use Moo;

with 'DX::Role::Op';

has member_var => (is => 'ro', required => 1);
has coll_var => (is => 'ro', required => 1);

sub run {
  my ($self, $state) = @_;
  ($state, my %args) = $self->_expand_args($state,
    member => $self->member_var,
    of => $self->coll_var
  );
  my ($member, $of) = @args{qw(member of)};
  die "member bound" if $member->is_bound;
  my $set = $state->facts->{$of->bound_value};
  my $stream = $set->to_stream;
  return $state->bind_stream_then($member, $stream, $self->next);
}

1;
